// Do not remove the include below
#include "amariOscillator.h"
#include "SensorAktor.h"
#include "MotorL293.h"

#define o1 13
#define o2 12
#define o3 11
#define o4 10

#define i1 2
#define i2 3
//state variable u for excitatory neuron
float u= .0;
//external stimulus s_u for excitatory neuron 1
float s_u=0;
//resting level h_u for excitatory neuron 1
float h_u=.0;
//self interaction weight c_u1
float c_uu=1.5;
//time scale tau_u for excitatory neuron 1
float tau_u = 200;
//rate of change d_u of excitatory neuron 1
float d_u=0;

//state variable v for neuron 2
float v= 0.0;
//external stimulus s_u for neuron 2
float s_v=0;
float h_v=-1;
float c_vv=0;
float d_v=0;

float c_uv = -1.5;
float c_vu = 1.5;
float tau_v = 200;

float beta=20;
//time measuring variable
unsigned long t;
//delta time (time difference between two iterations)
unsigned long dt;
// old time (time measured in previous iteration)
unsigned long ot;
float noise;
float c_n=0.1;

MotorL293 myMotor;
// poti value
int potiValue = 0;


void setup()
{
  pinMode(led1,OUTPUT);
  pinMode(led2,OUTPUT);
  ot = millis();
  randomSeed(analogRead(0));
  myMotor.attach(motor1_1, motor1_2, pwmMotor1);
}
/****threshold function of sigmoidal shape  **/
float sigmoid(float x,float beta)
{
  return 1/(1 + exp(-x*beta) );
}


void loop()
{
  t=millis();
  // read poti (value between 0 and 1023)
  potiValue = analogRead(poti);
  // scale poti value to use it with setPower (value between 0 and 254)
  potiValue = map(potiValue, 0 , 1023, 0, 254);
  // set speed of motor using poti value (value between 0 and 254)
  myMotor.setPower(potiValue);

  //measure time since last call of loop
  dt=t- ot;
  ot=t;
  if(dt>tau_u)
  {
    dt=tau_u/2;
  }
  noise = 1/1000*random(1000)-.5;

  d_u = dt*1./tau_u * (- u + s_u + h_u  +c_uu*sigmoid(u,beta)  +c_uv * sigmoid(v,beta) + c_n*noise ) ;
  u = u + d_u;
  d_v = dt*1./tau_v * (- v + s_v + h_v  +c_vv*sigmoid(v,beta)  +c_vu* sigmoid(u,beta)  ) ;
  v = v + d_v;
  int u_out= round(  sigmoid(u,beta));
  myMotor.setDirection(u_out);
  digitalWrite(led1,u_out);
  digitalWrite(led2,1-u_out);

}

